library FunctionSearcher;

uses
  SysUtils,
  Windows,
  PE_Files,
  CADt;

const
  { vlType constants }
  GetVBProject = 1;
  SetVBProject = 2;
  GetFileName = 3;              // (v3.5+)
  IsNativeCompilation = 4;      // (v3.5+)
  ClearAllBuffers = 5;          // need if your plugin decompile new language and need to clear all structures (v3.9+)
  GetCompiler = 6;              // 1 - vb, 2 - .net, 3 - delphi, 4 - unknown (v3.9+)
  IsPacked = 7;                 // 1 - packed, 0 - not packed (v3.9+)
  SetStackCheckBoxValue = 8;    // 0 - unchecked, 1 - checked (v3.9+)
  SetAnalyzerCheckBoxValue = 9; // 0 - unchecked, 1 - checked (v3.9+)
  GetVBFormName = 10;
  SetVBFormName = 11;
  GetVBForm = 12;
  SetVBForm = 13;
  GetVBFormCount = 14;
  GetSubMain = 20;
  SetSubMain = 21;
  GetModuleName = 30;
  SetModuleName = 31;
  GetModule = 32;
  SetModule = 33;
  GetModuleStringReferences = 34;
  SetModuleStringReferences = 35;
  GetModuleCount = 36;
  GetModuleFunctionName = 40;
  SetModuleFunctionName = 41;
  GetModuleFunctionAddress = 42;
  SetModuleFunctionAddress = 43;
  GetModuleFunction = 44;
  SetModuleFunction = 45;
  GetModuleFunctionStrRef = 46;
  SetModuleFunctionStrRef = 47;
  GetModuleFunctionCount = 48;
  GetActiveText = 50;
  SetActiveText = 51;
  GetActiveTextAsRichText = 52;
  SetActiveTextAsRichText = 53;
  SetActiveTextLine = 54;
  GetActiveModuleCoordinats = 55; // (v3.5+)
  GetVBDecompilerPath = 56;       // (v3.5+)
  GetModuleFunctionCode = 57;     // in "fast decompilation" mode (v3.5+)
  SetStatusBarText = 58;          // (v3.5+)
  UpdateAll = 100;
type
  TVBDPluginEngine = function(vlType :Integer; vlNumber :Integer; vlFnNumber :Integer; vlNewValue: PChar) :WideString; stdcall;
  TPE_File=class(Pe_File);
var
Pe:TPE_File;
Options: TMnemonicOptios;
ByteUsable:pointer;
Engine:pointer;
FnNumber:dword;

function DisAsmFunction(var CodeAddres: dword; CodeVA: dword):string; stdcall;
var
 cPtr: pbyte;
 Len, Readed: dword;
 Command: TDisCommand;
 Instr: TInstruction;
 CmdBuff: array [0..20] of Byte;
 TmpBuff: array [0..255] of Char;
begin
  cPtr := ptr(CodeAddres);
  Options.AlternativeAddres := CodeVA;
  ZeroMemory(@Instr, SizeOf(TInstruction));
  ZeroMemory(@Command, SizeOf(TDisCommand));
  if not ReadProcessMemory(dword(-1), cPtr, @CmdBuff, 16, Readed) then Exit;
  Len := InstrDecode(@CmdBuff, @Instr, false);
  InstrDasm(@Instr, @Command, false);
  MakeMnemonic(TmpBuff, @Command, @Options);
  DisAsmFunction:=string(TmpBuff);
  inc (CodeAddres,Len);
end;


{
 Get some value from VB Decompiler structure
 vlPluginEngine - pointer to VB Decompiler CallBack function
 vlType - type of getted value (FormName, SubMain, ...)
 vlNumber - form or module index or zero
 vlFnNumber - function index (for 40-47 vlType's)
}
function GetValue(vlPluginEngine: pointer; vlType: integer; vlNumber: integer; vlFnNumber: integer): string;
var
  pStr      : pchar;
  wStr      : WideString;
  ptrString : pointer;
begin
  asm
    push pStr
    push vlFnNumber
    push vlNumber
    push vlType
    call vlPluginEngine;
    mov ptrString,eax
  end;
  pointer(wStr):=ptrString;
  result:=string(wStr);
end;

{
 Set some value to VB Decompiler structure
 vlPluginEngine - pointer to VB Decompiler CallBack function
 vlType - type of setted value (FormName, SubMain, ...)
 vlNumber - form or module index or zero
 vlFnNumber - function index (for 40-47 vlType's)
}
function SetValue(vlPluginEngine: pointer; vlType: integer; vlNumber: integer; vlFnNumber: integer; vlNewValue: pchar): pchar;
asm
  push vlNewValue
  push vlFnNumber
  push vlNumber
  push vlType
  call vlPluginEngine;
  mov result,eax
end;

{
 VBDecompilerPluginName fucntion (started on VB Decompiler load)
 VBDecompilerHWND - handle to VB Decompiler window
 RichTextBoxHWND - handle to VB Decompiler RichEdit window
 Buffer - buffer of 100 chars. Copy name of your plugin here
 Void - reserved value
}
procedure VBDecompilerPluginName(VBDecompilerHWND: integer; RichTextBoxHWND: integer; Buffer: pointer; Void: integer);export;stdcall;
var
  strName: pchar;
begin
  strName:='Functions Searcher'#0;
  movememory(Buffer,strName,Length(strName));
end;

procedure SearchProc(CurrentAddr:dword;Phizical:dword;Rec:dword);stdcall;
var
 HexAddr:string;
 DecAddr:dword;
 Ext:boolean;
 Code:string[255];
 OldAddr:dword;
begin
  Ext:=false;
  Code:='';
  OldAddr:=CurrentAddr;

  Code:=trim(DisAsmFunction(CurrentAddr,0));
  CurrentAddr:=OldAddr;
  if Copy(Code,1,5)<>'jmp [' then begin
    SetValue(Engine,SetModuleFunctionName,0,FnNumber,pchar('Proc'));
    SetValue(Engine,SetModuleFunction,0,FnNumber,pchar('@VBDN@'+IntToHex(Phizical+Pe.PE_Header.Image_Base,8)));
    SetValue(Engine,SetModuleFunctionAddress,0,FnNumber,pchar(inttostr(Phizical+Pe.PE_Header.Image_Base)));
    inc(FnNumber);
    repeat
      Code:=trim(DisAsmFunction(CurrentAddr,0));
      if copy(Code,1,4)='call' then begin
        if copy(Code,6,1)='$' then begin
          HexAddr:=copy(Code,8,8);
          DecAddr:=StrToInt('$' + HexAddr);
          if copy(Code,7,1)='-' then DecAddr:=-DecAddr;
          SearchProc(CurrentAddr+DecAddr-5,Phizical+DecAddr+CurrentAddr-OldAddr-5,Rec+1);
        end;
      end;
      if Copy(Code,1,3)='ret' then Ext:=true;
      if Code='add [eax], al' then Ext:=true;
      if Code='invalid' then Ext:=true;
    until(Ext=true);
  end;
end;

{
 VBDecompilerPluginLoad fucntion
 VBDecompilerHWND - handle to VB Decompiler window
 RichTextBoxHWND - handle to VB Decompiler RichEdit window
 Buffer - buffer of 100 chars. Copy name of your plugin here
 PluginEngine - VB Decompiler CallBack function
}
procedure VBDecompilerPluginLoad(VBDecompilerHWND: DWORD; RichTextBoxHWND: DWORD; Buffer: Pointer; PluginEngine: Pointer);export;stdcall;

type
pbyte=^byte;

var
 FileName: string;
 EntryPoint:DWord;

begin
  FileName:=GetValue(PluginEngine,GetFileName,0,0);
  Engine:=PluginEngine;
  SetValue(Engine,ClearAllBuffers,0,0,'');
  SetValue(Engine,SetVBFormName,0,0,pchar('End of forms :)'));
  SetValue(Engine,SetModuleName,0,0,pchar('Mod0'));
  SetValue(Engine,SetModuleName,1,0,pchar('End of forms :)'));

  if FileName<>'' then begin
    PE:=TPE_File.Create;
    PE.LoadFromFile(FileName);
    if word(PE.pMap)<>0 then begin
      Options.RealtiveOffsets := true;
      Options.AddAddresPart := false;
      Options.AddHexDump := false;
      Options.MnemonicAlign := 30;
      EntryPoint:=dword(PE.pMap)+PE.PE_Header.Entry_Point_RVA;
      GetMem(ByteUsable,Pe.File_Size);
      FnNumber:=0;
      SearchProc(EntryPoint,PE.PE_Header.Entry_Point_RVA,0);
      SetValue(Engine,SetModuleFunctionName,0,FnNumber,pchar('End of forms :)'));
      SetValue(Engine,UpdateAll,0,0,pchar(''));
    end;
    PE.Destroy;
  end;
end;


{
 VBDecompilerPluginAuthor fucntion (used for detect author of plugin)
 VBDecompilerHWND - handle to VB Decompiler window
 RichTextBoxHWND - handle to VB Decompiler RichEdit window
 Buffer - buffer of 100 chars. Copy your name and mail here
 Void - reserved value
}
procedure VBDecompilerPluginAuthor(VBDecompilerHWND: integer; RichTextBoxHWND: integer; Buffer: pointer; Void: integer);export;stdcall;
var
  strName: pchar;
begin
  strName:='ShackS, ShackS@mail.ru'#0;
  movememory(Buffer,strName,Length(strName));
end;

Exports
  VBDecompilerPluginName,
  VBDecompilerPluginLoad,
  VBDecompilerPluginAuthor;

begin
end.
